#ifdef __cplusplus
extern "C" {
#endif

/* ************************************************************************ */
/*                                                                          */
/*      Provide MS Windows compatability                                    */
/*                                                                          */
/* ************************************************************************ */


#if defined(INCL_WININCLUDED)                   /* OS/2 Relesase 1.x        */
typedef USHORT            CHTYPE;
typedef CHTYPE FAR        *PCHTYPE;
typedef LONG FAR         *LPLONG;
BOOL    APIENTRY ChartPaint(HWND, HPS);
BOOL    APIENTRY ChartAnnotatePaint(HWND, HPS);
#else

#if defined(CHART_OS2_32)                       /* OS/2 Release 2.x         */
typedef USHORT            CHTYPE;
typedef CHTYPE FAR        *PCHTYPE;
typedef LONG FAR         *LPLONG;
BOOL    APIENTRY ChartPaint(HWND, HPS);
BOOL    APIENTRY ChartAnnotatePaint(HWND, HPS);
#ifndef FAR
#define FAR
#endif
#ifndef far
#define far
#endif

#else                                          /* Windows 3.x              */
#ifndef WIN32
#define APIENTRY FAR PASCAL
typedef unsigned int      USHORT;
typedef unsigned int far  *PUSHORT;
typedef int far           *PSHORT;
typedef struct _POINTL {    /* ptl  */
    int   x;
    int   y;
} POINTL;
typedef POINTL  FAR  *PPOINTL;
typedef RECT far             *PRECTL;
typedef int                  SHORT;
#else
// #define RECTL RECT
#endif
typedef unsigned long     ULONG;
typedef unsigned int      CHTYPE;
typedef char far          *PCH;
typedef char far          *PSZ;
typedef unsigned long far *PULONG;
typedef HWND              HAB;
typedef CHTYPE far        *PCHTYPE;
typedef char              CHAR;
typedef unsigned char     UCHAR;

#define CLR_WHITE                    -2L
#define CLR_BLACK                    -1L
#define CLR_BACKGROUND                0L
#define CLR_BLUE                      1L
#define CLR_RED                       2L
#define CLR_PINK                      3L
#define CLR_GREEN                     4L
#define CLR_CYAN                      5L
#define CLR_YELLOW                    6L
#define CLR_NEUTRAL                   7L
#define CLR_DARKGRAY                  8L
#define CLR_DARKBLUE                  9L
#define CLR_DARKRED                  10L
#define CLR_DARKPINK                 11L
#define CLR_DARKGREEN                12L
#define CLR_DARKCYAN                 13L
#define CLR_BROWN                    14L
#define CLR_PALEGRAY                 15L

#define MARKSYM_DEFAULT               0L
#define MARKSYM_CROSS                 1L
#define MARKSYM_PLUS                  2L
#define MARKSYM_DIAMOND               3L
#define MARKSYM_SQUARE                4L
#define MARKSYM_SIXPOINTSTAR          5L
#define MARKSYM_EIGHTPOINTSTAR        6L
#define MARKSYM_SOLIDDIAMOND          7L
#define MARKSYM_SOLIDSQUARE           8L
#define MARKSYM_DOT                   9L
#define MARKSYM_SMALLCIRCLE          10L

#define LINETYPE_DEFAULT              0L
#define LINETYPE_DOT                  1L
#define LINETYPE_SHORTDASH            2L
#define LINETYPE_DASHDOT              3L
#define LINETYPE_DOUBLEDOT            4L
#define LINETYPE_LONGDASH             5L
#define LINETYPE_DASHDOUBLEDOT        6L
#define LINETYPE_SOLID                7L
#define LINETYPE_INVISIBLE            8L

#define PATSYM_DEFAULT                0L
#define PATSYM_DENSE1                 1L
#define PATSYM_DENSE2                 2L
#define PATSYM_DENSE3                 3L
#define PATSYM_DENSE4                 4L
#define PATSYM_DENSE5                 5L
#define PATSYM_DENSE6                 6L
#define PATSYM_DENSE7                 7L
#define PATSYM_DENSE8                 8L
#define PATSYM_VERT                   9L
#define PATSYM_HORIZ                 10L
#define PATSYM_DIAG1                 11L
#define PATSYM_DIAG2                 12L
#define PATSYM_DIAG3                 13L
#define PATSYM_DIAG4                 14L
#define PATSYM_NOSHADE               15L
#define PATSYM_SOLID                 16L
#define PATSYM_HALFTONE              17L
#define PATSYM_BLANK                 64L

BOOL    APIENTRY ChartPaint(HWND, HDC);
BOOL    APIENTRY ChartAnnotatePaint(HWND, HDC);
#endif                               /* End of Windows                       */
#endif

#define MARKSYM_TRIANGLEUP           20L
#define MARKSYM_TRIANGLEDOWN         21L
#define MARKSYM_SOLIDTRIANGLEUP      22L
#define MARKSYM_SOLIDTRIANGLEDOWN    23L
#define MARKSYM_LARGECIRCLE          24L
#define MARKSYM_DOCUMENT             25L
#define MARKSYM_NULL                 30L

/* ************************************************************************* */
/* ************************************************************************* */
/*                                                                           */
/*      Structures                                                           */
/*                                                                           */
/* ************************************************************************* */
/* ************************************************************************* */

typedef  struct _CHARTPOINTER {
   BOOL    success;            /* Success indicator                          */
   USHORT  type;               /* Type of object (data point, title etc.)    */
   USHORT  group;              /* Group number                               */
   USHORT  point;              /* Point number within group                  */
   float   value;              /* Value if data point                        */
   LONG    xLeft;              /* Location of the object                     */
   LONG    yBottom;            /* Location of the object                     */
   LONG    xRight;             /* Location of the object                     */
   LONG    yTop;               /* Location of the object                     */
} CHARTPOINTER;

typedef  struct _CHARTVERSION {
   USHORT  version;            /* DLL version                                */
   USHORT  mod;                /* DLL modification level                     */
   USHORT  revision_level;     /* DLL modification revision level            */
   ULONG   res[6];             /* Reserved                                   */
} CHARTVERSION;

typedef  struct _CHARTTIME {
   USHORT  year;               /* 0000 - 7000 AD                             */
   USHORT  month;              /* 1 - 12                                     */
   USHORT  day;                /* 1 - 31                                     */
   USHORT  hour;               /* 0 - 23                                     */
   USHORT  minute;             /* 0 - 59                                     */
   USHORT  second;             /* 0 - 59                                     */
   char    flags;              /* Reserved for flags                         */
   char    res;                /* Reserved                                   */
} CHARTTIME;

#define CH_DAYLIGHT_SAVINGS        0x01

typedef  struct _CHARTHIGHLIGHT {
   LONG    cb;                 /* Length of structure                        */
   USHORT  point;              /* Data point                                 */
   ULONG   flags;              /* Data point highlight flags                 */
   ULONG   color;              /* Color for solid shapes                     */
   ULONG   line_color;         /* Color for lines                            */
   ULONG   rgb_light;          /* RGB value for front of 3-D items           */
   ULONG   rgb_shade;          /* RGB value for side walls of 3-D items      */
   ULONG   marker;             /* Overriding marker symbol                   */
   ULONG   pattern;            /* Pattern for bars on charts                 */
   USHORT  bitmap;             /* OS-2 Bitmap                                */
   ULONG   pattern_color;      /* Pattern color                              */
} CHARTHIGHLIGHT;

#define CH_HL_NOT_CONNECTED       0x0001     /*  Not conneted to prior point */
#define CH_HL_COLOR               0x0002     /*  System color                */
#define CH_HL_LINE_COLOR          0x0004     /*  System color                */
#define CH_HL_RGB                 0x0008     /*  RGB color values provided   */
#define CH_HL_MARKER              0x0010     /*  Marker symbol required      */
#define CH_HL_PATTERN             0x0020     /*  Pattern required            */
#define CH_HL_PATTERN_OVERLAY     0x0040     /*  Pattern overlay color       */
#define CH_HL_PATTERN_COLOR       0x0080     /*  Pattern color               */
#define CH_HL_HORIZONTAL_LINE     0x0100     /*  Horizontal line             */
#define CH_HL_VERTICAL_LINE       0x0200     /*  Vertical line               */
#define CH_HL_LARGECIRCLE         0x0400     /*  Large circle symbol         */
#define CH_HL_DOCUMENT            0x0800     /*  Document symbol             */

typedef  struct _CHARTFONT {
   LONG    cb;                 /* Length of structure                        */
   ULONG   flags;              /* Reserved                                   */
   CHAR    szRasterName[36];   /* Name of font for display                   */
   USHORT  usPointSize[6];     /* Point size (system) from lowest to highest */
   CHAR    szVectorName[36];   /* Name of font for printing                  */
   float   VectorMagnify;      /* Reserved                                   */
} CHARTFONT;

typedef  struct _CHARTPRINT {
   LONG    cb;                 /* Length of structure                        */
   ULONG   flags;              /* Reserved                                   */
   PSZ     pAbortProc;         /* Pointer to abort procedure for Windows     */
   CHAR    szDeviceName[32];   /* Reserved                                   */
} CHARTPRINT;

#define CH_OPTIONS_DIALOG       0x00000001L
#define CH_LANDSCAPE            0x00000002L

typedef  struct _CHARTBITMAP {
   LONG    cb;                 /* Length of structure                        */
   ULONG   flags;              /* Flags - none currently defined             */
   USHORT  width;              /* Width of bitmap                            */
   USHORT  height;             /* Height of bitmap                           */
   USHORT  id;                 /* Resource ID                                */
   USHORT  module;             /* DLL module id if bit map in DLL            */
                               /*   else NULL if id from .RC file            */
} CHARTBITMAP;


#define CH_BITMAP               0x00000001L
#define CH_ICON                 0x00000002L

typedef  struct _CHARTRANGE {
   USHORT  sub_type;           /* Chart sub-type                            */
   USHORT  volume;             /* Reserved                                  */
   LONG    open_color;         /* Color for open value                      */
   LONG    close_color;        /* Color for close value                     */
   ULONG   flags[8];           /* Indicator flags for 8 groups              */

} CHARTRANGE;


typedef  struct _CHARTTICKS {
   LONG    cb;                 /* Length of structure                        */
   ULONG   flags;              /* Flags                                      */
   USHORT  minor;              /* Minor tick count                           */
   USHORT  major;              /* Minor tick count                           */
   USHORT  decimal;            /* digits to right of decimal                 */
   double  increment;          /* Increment value  (normal scale)            */
                               /*   Multiplier     (log scale)               */
   double  low;                /* Lowest tick value                          */
   double  high;               /* Highest tick value                         */
} CHARTTICKS;


#define CH_TICK_STRING      0x00000002L

#define CH_FRACTION_4       0x80000000L
#define CH_FRACTION_8       0x40000000L
#define CH_FRACTION_16      0x20000000L
#define CH_FRACTION_32      0x10000000L

typedef CHARTHIGHLIGHT far *PCHARTHIGHLIGHT;
typedef CHARTPOINTER far   *PCHARTPOINTER;
typedef CHARTVERSION far   *PCHARTVERSION;
typedef CHARTTIME    far   *PCHARTTIME;
typedef CHARTPRINT   far   *PCHARTPRINT;
typedef CHARTFONT    far   *PCHARTFONT;
typedef CHARTRANGE far     *PCHARTRANGE;
typedef CHARTBITMAP far    *PCHARTBITMAP;
typedef CHARTTICKS far     *PCHARTTICKS;

/* ************************************************************************* */
/* ************************************************************************* */
/*                                                                           */
/*      defines for API parameters                                           */
/*                                                                           */
/* ************************************************************************* */
/* ************************************************************************* */

#define CH_MAX_POINTS                   12288

#define CH_HEIGHT                           0
#define CH_WIDTH                            1
#define CH_DEPTH                            2

#define CH_USER_TICKS                       0
#define CH_BASIC                            1
#define CH_YEARS                            2
#define CH_MONTHS                           3
#define CH_WEEK_DAYS                        4
#define CH_DAYS                             5
#define CH_HOURS                            6
#define CH_HOURS_24                         7
#define CH_MINUTES                          9
#define CH_SECONDS                         10
#define CH_LEDGER                          11

#define CH_GROUP_1                          1
#define CH_GROUP_2                          2
#define CH_GROUP_3                          3
#define CH_GROUP_4                          4
#define CH_GROUP_5                          5
#define CH_GROUP_6                          6
#define CH_GROUP_7                          7
#define CH_GROUP_8                          8
#define CH_GROUP_9                          9
#define CH_GROUP_10                        10
#define CH_GROUP_11                        11
#define CH_GROUP_12                        12
#define CH_MAX_GROUP                       12

/*****************************************************************************/
/* CHARTPOINTER.type             API  ChartQueryLocation  ChartQueryPointer  */
/*****************************************************************************/

#define CH_LOC_LEGEND          0   /*         X                  X           */
#define CH_LOC_POINT           1   /*         X                  X           */
#define CH_LOC_TITLE           2   /*         X                  X           */
#define CH_LOC_LEFT_MARGIN     3   /*         X                  X           */
#define CH_LOC_RIGHT_MARGIN    4   /*         X                  X           */
#define CH_LOC_TOP_LEFT        5   /*         X                  X           */
#define CH_LOC_TOP_RIGHT       6   /*         X                  X           */
#define CH_LOC_BOTTOM_LEFT     7   /*         X                  X           */
#define CH_LOC_BOTTOM_RIGHT    8   /*         X                  X           */
#define CH_LOC_FOOTING         9   /*                            X           */
#define CH_LOC_X_TICK         10   /*         X                  X           */
#define CH_LOC_Y_TICK         11   /*         X                  X           */
#define CH_LOC_Z_TICK         12   /*         X                  X           */
#define CH_LOC_POINT_RIGHT    13   /*                            X           */
#define CH_LOC_POINT_LEFT     14   /*                            X           */
#define CH_LOC_GRAPHIC        15   /*         X                  X           */

/*****************************************************************************/
/* Message for ChartSendMsg (use only those documented)                      */
/*****************************************************************************/

#define CH_MARKER_LEGENDS        201    /* Use/Don't Marker symbol on legend   */
#define CH_BYPASS_CLIENT_ERASE   202    /* TRUE don't paint client background  */
#define CH_BYPASS_GRAPHIC_DRAW   203    /* TRUE don't draw in graphic area     */
#define CH_TOP_3D_GRAPHIC_FRAME  204    /* Display top & right sides of 3D     */
#define CH_GRID_WIDTH            205    /* Set line width for major tick marks */
#define CH_GRID_LINE_TYPE        206    /* Set type of line for ticks          */
#define CH_X_TICK_BALANCE        208    /* Evenly distribute x-axis text       */
#define CH_X_TICK_MULTILINE      209    /* Use 2 lines for x-axis text         */
#define CH_FULL_WIDTH_LEGENDS    210    /* Use entire chart width for legends  */
#define CH_POINT_FIGURE_VALUE    211    /* Base value for Point & Figure chart */
#define CH_POINT_FIGURE_UP       212    /* Up   value for Point & Figure chart */
#define CH_POINT_FIGURE_DOWN     213    /* Down value for Point & Figure chart */
#define CH_HPS                   214    /* Developer owned presentation space  */
#define CH_BYPASS_LEGENDS        215    /* Bypass legend display               */
#define CH_BYPASS_DATES          216    /* Bypass dates on time based displays */
#define CH_BYPASS_HOURS          217    /* Bypass hours on time based displays */
#define CH_LINE_FULL_WIDTH       218    /* Use full graphic area for line chart*/
#define CH_X_AXIS_TEXT_SKIP      219    /* No. of text strings to skip on axis */
#define CH_QUERY_AXIS            220    /* Determine values on x,y or z axis   */
#define CH_LINE_LEGENDS          221    /* Display line symbol in legend       */
#define CH_YZ_BYPASS_DECIMAL     222    /* No decimal points on y & z axis     */
#define CH_Y_AXIS_PERCENT_SIGN   223    /* Display % sign on y axis            */
#define CH_Z_AXIS_PERCENT_SIGN   224    /* Display % sign on z axis            */
#define CH_QUERY_FONT_USED       225    /* Obtain font size used in display    */
#define CH_FORCE_TOUCH           226    /* Force CH_TOUCH                      */
#define CH_BYPASS_X_AXIS_TEXT    227    /* Do not display x axis text          */
#define CH_Y_AXIS_CURRENCY       228    /* Country currency with numbers       */
#define CH_Z_AXIS_CURRENCY       229    /* Country currency with numbers       */
#define CH_BYPASS_DAYS           230    /* Bypass MTWTF or day number          */
#define CH_RESET_GROUP_COLORS    231    /* Reset group colors to defaults      */
#define CH_X_AXIS_CURRENCY       232    /* Country currency with numbers       */
#define CH_X_AXIS_PERCENT_SIGN   233    /* Display % sign on x axis            */
#define CH_ZAXIS_YDATA           234    /* Z-axis tied to high y-axis-data     */
#define CH_TIGHT_SCALES          235    /* Tighter Y and Z scales              */
#define CH_BYPASS_Z_EXCHANGE     236    /* Do not switch to CH_BAR_LINE        */
                                        /*   regions with z-axis requested     */
#define CH_X_AXIS_TEXT_CENTER    237    /* Place text between tick marks on    */
                                        /*   2D line charts                    */

#define CH_DRAW_SYMBOLS         2001    /* OS/2 draw symbols                   */
#define CH_VECTOR_FORCE         3000    /* OS/2 force vector fonts             */
#define CH_RASTER                  0    /*     Raster font for programmer ps   */
#define CH_VECTOR                  1    /*     Vector font for programmer ps   */

/* ************************************************************************* */
/*      Range Chart Options                                                  */
/* ************************************************************************* */

#define CH_OPEN            0x00000001L
#define CH_CLOSE           0x00000002L
#define CH_OPEN_INSIDE     0x00000004L
#define CH_CLOSE_INSIDE    0x00000008L

#define CH_NORMAL_RANGE    0
#define CH_POINT_FIGURE    1
#define CH_CANDLESTICK     2

#define CH_VERTICAL        0x00000001L
#define CH_DISPLAY         0x0001
#define CH_PRINTER         0x0002


#define CH_RIGHT_JUSTIFY      0x00000000L
#define CH_LEFT_JUSTIFY       0x00000001L
#define CH_CENTER_JUSTIFY     0x00000010L
#define CH_TOP_JUSTIFY        0x00000100L
#define CH_BOTTOM_JUSTIFY     0x00001000L
#define CH_VERTICAL_ANNOTATE  0x00010000L

#define CLR_DARKGRAY2     16L

/* ************************************************************************* */
/* ************************************************************************* */
/*                                                                           */
/*      Data types for chart data points                                     */
/*                                                                           */
/* ************************************************************************* */
/* ************************************************************************* */

#define CH_DATA_USHORT           0     /*              0 to         +65,536 */
#define CH_DATA_SHORT            1     /*        -32,767 to         +32,767 */
#define CH_DATA_ULONG            2     /*              0 to  +4,294,967,296 */
#define CH_DATA_LONG             3     /* -2,147,483,648 to  +2,147,483,648 */
#define CH_DATA_FLOAT            4     /* 10 to -38    thru      10 to  +38 */
#define CH_DATA_DOUBLE           5     /* 10 to -308   thru      10 to +308 */

/* ************************************************************************* */
/* ************************************************************************* */
/*                                                                           */
/*      Indicator used by ChartCreate, ChartSetType and other APIs           */
/*                                                                           */
/* ************************************************************************* */
/* ************************************************************************* */

#define CH_BAR                           0
#define CH_STACKED_BAR                   1
#define CH_COLUMN                        2
#define CH_LINE                          3
#define CH_SMOOTH_LINE                   4
#define CH_SCATTER                       5
#define CH_AREA                          6
#define CH_PIE                           7
#define CH_PER_BAR                       8
#define CH_BAR_LINE                      9
#define CH_NUMERIC_TABLE                10
#define CH_SYMBOL_TABLE                 11
#define CH_SPIKE                        12
#define CH_SQUARE_WAVE                  13
#define CH_HISTOGRAM                    14
#define CH_RANGE                        15
#define CH_HORIZONTAL_BAR               16
#define CH_HORIZONTAL_STACKED_BAR       17
#define CH_PLOT                         18
#define CH_OVERLAP_BAR                  19
#define CH_CONNECTED_SCATTER            20
#define CH_BAR_GOAL                     21
#define CH_X_PLOT                       22
#define CH_MIXED                        23
#define CH_FLOAT_BAR                    24
#define CH_FLOAT_STACKED_BAR            25
#define CH_MATRIX                       26
#define CH_STACKED_AREA                 27

/* ************************************************************************* */
/* ************************************************************************* */
/*                                                       Set                 */
/*      Chart Options                           Create  Colors               */
/*                                                                           */
/* ************************************************************************* */
/* ************************************************************************* */

#define CH_FRAME                0x00000001L    /*  X      X                  */
#define CH_GRAPHIC_FRAME        0x00000002L    /*  X      X                  */
#define CH_CLIENT               0x00000004L    /*         X                  */
#define CH_TIME_BASED           0x00000004L    /*  X                         */
#define CH_GRAPHIC              0x00000008L    /*         X                  */
#define CH_TITLE                0x00000010L    /*         X                  */
#define CH_FOOTING              0x00000020L    /*         X                  */
#define CH_LEFT_MARGIN          0x00000040L    /*         X                  */
#define CH_RIGHT_MARGIN         0x00000080L    /*         X                  */
#define CH_Y_GRID               0x00000100L    /*  X      X                  */
#define CH_X_GRID               0x00000200L    /*  X      X                  */
#define CH_HORIZONTAL           0x00000400L    /*  X                         */
#define CH_GRAPHIC_WALL         0x00000400L    /*         X                  */
#define CH_X_TICK               0x00000800L    /*         X                  */
#define CH_Y_TICK               0x00001000L    /*         X                  */
#define CH_Z_TICK               0x00002000L    /*         X                  */
#define CH_X_TICK_TEXT          0x00004000L    /*         X                  */
#define CH_Y_TICK_TEXT          0x00008000L    /*         X                  */
#define CH_Z_TICK_TEXT          0x00010000L    /*         X                  */
#define CH_MARKER               0x00010000L    /*  X                         */
#define CH_CONNECTED            0x00010000L    /*  X                         */
#define CH_SORT                 0x00040000L    /*  X                         */
#define CH_NORMAL               0x00040000L    /*         X                  */
#define CH_SCOPE                0x00040000L    /*         X                  */
#define CH_LEGEND               0x00080000L    /*         X                  */
#define CH_Z_GRID               0x00020000L    /*  X      X                  */
#define CH_NO_ZEROES            0x00100000L    /*  X                         */
#define CH_FLOAT_SCALE          0x00200000L    /*  X                         */
#define CH_TOUCH                0x00400000L    /*  X                         */
#define CH_MINOR_GRID           0x00800000L    /*  X      X                  */
#define CH_PERCENT              0x00000008L    /*  X                         */



/* ************************************************************************* */
/*                                                                           */
/*      API Proto-type statements                                            */
/*                                                                           */
/* ************************************************************************* */


HWND    APIENTRY ChartCreate(HWND, CHTYPE, ULONG, PRECTL, PUSHORT, USHORT,
                             USHORT, USHORT, USHORT);

BOOL    APIENTRY ChartSetRect(HWND, PRECTL);

BOOL    APIENTRY ChartData(HWND, USHORT, PUSHORT, USHORT, USHORT, USHORT, PCH);

BOOL    APIENTRY ChartText(HWND, ULONG, PCH);

BOOL    APIENTRY ChartTexts(HWND, PCH, PCH, PCH, PCH);

BOOL    APIENTRY ChartVisible(HWND);

BOOL    APIENTRY ChartDestroy(HWND);

BOOL    APIENTRY ChartSetFrame(HWND, BOOL);

BOOL    APIENTRY ChartSetXTicks(HWND, USHORT, USHORT, USHORT);

BOOL    APIENTRY ChartSetOptions(HWND, ULONG);

BOOL    APIENTRY ChartQueryOptions(HWND, PULONG);

BOOL    APIENTRY ChartSetType(HWND, CHTYPE, BOOL);

BOOL    APIENTRY ChartQueryType(HWND, PCHTYPE);

BOOL    APIENTRY ChartLegend(HWND, USHORT, PCH);

BOOL    APIENTRY ChartSetColor(HWND, ULONG, LONG);

BOOL    APIENTRY ChartSetGroupColor(HWND, USHORT, SHORT);

BOOL    APIENTRY ChartSetRegions(HWND, USHORT, USHORT, USHORT, USHORT, USHORT);

BOOL    APIENTRY ChartQueryDimensions(HWND, PUSHORT);

BOOL    APIENTRY ChartSetDimensions(HWND, USHORT);

BOOL    APIENTRY ChartSetMaxXValue(HWND, double);

BOOL    APIENTRY ChartSetMaxYValue(HWND, double);

BOOL    APIENTRY ChartSetMaxZValue(HWND, double);

BOOL    APIENTRY ChartSetMinXValue(HWND, double);

BOOL    APIENTRY ChartSetMinYValue(HWND, double);

BOOL    APIENTRY ChartSetMinZValue(HWND, double);

BOOL    APIENTRY ChartSetGroupCount(HWND ,USHORT );

BOOL    APIENTRY ChartSetPointCount(HWND ,USHORT );

BOOL    APIENTRY ChartSetRGB(HWND ,ULONG ,ULONG );

BOOL    APIENTRY ChartSetMarker(HWND ,LONG );

BOOL    APIENTRY ChartSetLineWidth(HWND ,LONG );

BOOL    APIENTRY ChartSetGroupRGB(HWND ,USHORT ,ULONG ,ULONG );

BOOL    APIENTRY ChartSetGroupMarker(HWND ,USHORT ,LONG );

BOOL    APIENTRY ChartSetGroupLineType(HWND ,USHORT ,LONG );

BOOL    APIENTRY ChartSetLineType(HWND ,LONG );

BOOL    APIENTRY ChartSetXTicksFloat(HWND, USHORT, float, float, PCH);

BOOL    APIENTRY ChartSetXTicksString(HWND, USHORT ,USHORT, PCH);

BOOL    APIENTRY ChartSetXTicksStringBasic(HWND, USHORT, PCH);

BOOL    APIENTRY ChartOptions(HWND, USHORT, USHORT, PCH);

BOOL    APIENTRY ChartVolume(HWND, USHORT, PUSHORT);

BOOL    APIENTRY ChartSetWindow(HWND, HWND);

BOOL    APIENTRY ChartDataAppend(HWND,USHORT, USHORT, PUSHORT, BOOL);

BOOL    APIENTRY ChartSetTableFormat(HWND, PCH, PCH, PCH, USHORT, USHORT);

BOOL    APIENTRY ChartSetColorTable(HWND, ULONG, USHORT, ULONG[], float[], PCH);

BOOL    APIENTRY ChartSetSymbolGroup(HWND, USHORT);

USHORT  APIENTRY ChartGetData(HWND, USHORT, PCH, float []);

BOOL    APIENTRY ChartOutputMetaFile(HWND , PCH );

BOOL    APIENTRY ChartQueryPointer(HWND, LONG, LONG, PCHARTPOINTER);

BOOL    APIENTRY ChartQueryVersion(PCHARTVERSION);

BOOL    APIENTRY ChartSetCountryCode(HWND, USHORT);

BOOL    APIENTRY ChartQueryLocation(HWND,  PCHARTPOINTER);

USHORT  APIENTRY ChartGetLastError(HWND);

BOOL    APIENTRY ChartTimeReference(HWND, USHORT, USHORT, PCHARTTIME);

BOOL    APIENTRY ChartSetTimeRange(HWND, PCHARTTIME, PCHARTTIME);

BOOL    APIENTRY ChartDataHighlight(HWND, USHORT, USHORT, PCHARTHIGHLIGHT);

BOOL    APIENTRY ChartSetNormalDataScope(HWND, double, double);

BOOL    APIENTRY ChartSetFont(HWND, PCHARTFONT);

BOOL    APIENTRY ChartPrint(HWND, PCH, PCHARTPRINT);

BOOL    APIENTRY ChartSetYTicksString(HWND, USHORT, USHORT, PCH []);

BOOL    APIENTRY ChartRegisterBitmap(HWND, PCHARTBITMAP, PUSHORT);

BOOL    APIENTRY ChartReleaseBitmap(HWND, USHORT);

BOOL    APIENTRY ChartSetTextFontSize(HWND,ULONG, SHORT);

BOOL    APIENTRY ChartSetZAxisGroup(HWND, USHORT, BOOL);

SHORT   APIENTRY ChartQueryTextFontSize(HWND,ULONG, PCH);

SHORT   APIENTRY ChartQueryExtendedError(HWND);

BOOL    APIENTRY ChartQueryTextFontSizes(HWND ,USHORT, USHORT, PULONG , PRECTL, PCH [], PSHORT);

BOOL    APIENTRY ChartSendMsg(HWND, USHORT, ULONG, ULONG);

BOOL    APIENTRY ChartSendMsgVP(HWND, USHORT, ULONG, PCH);

BOOL    APIENTRY ChartSendMsgPV(HWND, USHORT, PCH, ULONG);

BOOL    APIENTRY ChartSendMsgPP(HWND, USHORT ,PCH, PCH);

BOOL    APIENTRY ChartSetGroupPattern(HWND, USHORT, ULONG, BOOL, LONG);

BOOL    APIENTRY ChartSetPattern(HWND, ULONG, ULONG, BOOL, LONG);

BOOL    APIENTRY ChartSetTicks(HWND, ULONG, PCHARTTICKS);

HWND    APIENTRY ChartAnnotate(HWND, USHORT, PRECTL, LONG, ULONG, PCH);

BOOL    APIENTRY ChartAnnotateDestroy(HWND);

BOOL    APIENTRY ChartAnnotateRelease(HWND, HWND);

BOOL    APIENTRY ChartSetGroupStyle(HWND, USHORT, USHORT, ULONG);

BOOL    APIENTRY ChartClipboard(HWND);

BOOL    APIENTRY ChartQueryGroupColor(HWND, USHORT, LPLONG);

BOOL    APIENTRY ChartDataUpdatePoint(HWND ,USHORT , USHORT , USHORT , PUSHORT ,BOOL );

BOOL    APIENTRY ChartGetValue(HWND, USHORT, LONG,  LONG, double *);

BOOL    APIENTRY ChartGetDisplacement(HWND, USHORT, LONG,  double, LPLONG);

/* ************************************************************************* */
/* ************************************************************************* */
/*                                                                           */
/*       Error return values from function API function calls                */
/*                                                                           */
/* ************************************************************************* */
/* ************************************************************************* */

#define Chart_OK                      0
#define Chart_invalid_client          1
#define Chart_not_defined             2
#define Chart_no_memory               3
#define Chart_invalid_color           4
#define Chart_invalid_parameter       5
#define Chart_datapoints_excess       6
#define Chart_invalid_data_type       7
#define Chart_invalid_group           8
#define Chart_no_data                 9
#define Chart_invalid_dimensions     10
#define Chart_invalid_tick_text      11
#define Chart_memory_release         12
#define Chart_region_recalculated    13
#define Chart_invalid_option         14
#define Chart_invalid_chart_type     15
#define Chart_invalid_marker         16
#define Chart_invalid_line_type      17
#define Chart_invalid_DLL            18
#define Chart_area_too_small         19
#define Chart_invalid_count          20
#define Chart_invalid_pointer        21
#define Chart_no_data_available      22
#define Chart_meta_file              23
#define Chart_time_data_balance      24
#define Chart_invalid_time           25
#define Chart_invalid_pattern        26
#define Chart_invalid_font           27
#define Chart_invalid_printer        28
#define Chart_time_start_end         29
#define Chart_invalid_bitmap         30
#define Chart_bitmap_not_registered  31
#define Chart_invalid_device         32
#define Chart_invalid_text_area      33
#define Chart_invalid_font_size      34
#define Chart_invalid_normal_data    35
#define Chart_invalid_axis           36
#define Chart_invalid_text_direction 37
#define Chart_clipboard_not_open     38

#ifdef __cplusplus
}
#endif

